<template lang="pug">
.error-page
  header-block.header--relative.header--always-visible
  .error-page__inner
    .container.error-page__container
      .error-page__clouds
        span
      .error-page__lines
        span
        span
        span
        span
      .error-page__header
        .error-page__go-back(v-if="hasPrevPage")
          span(
            @click="$router.back()"
          ) {{ $t('forms.buttons.back') }}
      .error-page__code
        p {{ code }}
        .error-page__code-clouds
          span
          span
          span
          span
          span
          span
          span

      .error-page__line
      .error-page__title(v-if="title") {{ title }}
      .error-page__buttons
        nuxt-link.btn.btn--secondary.btn--simple(
          :to="{ name: 'index', params: { locale } } | url"
        ) {{ $t('goBackToMain') }}
        nuxt-link.btn.btn--simple(
          :to="{ name: 'contacts', params: { locale } } | url"
        ) {{ $t('aboutInfo') }}
</template>

<script>
import { pageMixin } from '../mixins/pages'
import { layoutMixin } from '../mixins/layouts'
import config from '../config'
import { mapState } from 'vuex'
import { url } from '../filters'
import { hasPrevPageMixin } from '../mixins/has-prev-page'

export default {
  name: 'LayoutError',

  computed: {
    ...mapState({
      locale: state => state.locale
    })
  },

  async created () {
    this.title = this.$t('errors.404')
    this.code = 404
    try {
      await this.$store.dispatch('vars/settings')
    } catch (e) { console.log(e) }

    if (this.error) {
      console.log(this.error)

      if (this.error.statusCode || 0) {
        const status = this.error.statusCode
        this.code = status
        if (status === 400) {
          this.title = this.$t('errors.400')
        } else if (status === 403) {
          this.title = this.$t('errors.403')
        } else if (status === 404) {
          this.title = this.$t('errors.404')
        } else if (status === 500) {
          this.title = this.$t('errors.500')
        }

        if (
          typeof this.error.statusCode.indexOf !== 'undefined' &&
            this.error.statusCode.indexOf('Error') >= 0
        ) {
          this.title = this.$t('error')
        }
      }
    }
  },

  data () {
    return {
      title: '',
      code: '',
      config
    }
  },

  filters: { url },
  head () {
    return {
      bodyAttrs: {
        class: config.siteID === 2 ? 'theme-light bg-light' : 'bg-light'
      },
      title: this.prepareTitle(this.title)
    }
  },

  layout: 'default',
  mixins: [hasPrevPageMixin, layoutMixin, pageMixin],

  mounted () {
    if (
      this.error &&
        this.error.message &&
        this.error.message.indexOf &&
        this.error.message.indexOf('Loading chunk') >= 0 &&
        this.error.message.indexOf('failed') > 0
    ) {
      if (process.browser) {
        this.error.statusCode = 'Error'
        window.location.reload()
      }
    }
  },

  props: {
    error: {
      type: [Object, null],
      required: false,
      default: null
    }
  }
}
</script>
